SystemOrganization addCategory: #'GBT-DSL_LittleCompany'!

TestCase subclass: #HelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!HelloWorld class methodsFor: 'example' stamp: 'hk 6/12/2016 15:14'!
example
	GbtSVO initializeAll.
	(GbtThingEditor on: self hello) openWithSpec! !

!HelloWorld class methodsFor: 'things' stamp: 'hk 5/12/2016 17:09'!
hello
	^GbtThing newStruct: 'hello' define: {
		{ #summary . 'Hello #yourName'}	.
		{ #yourName . #val: . ''}	}! !

TestCase subclass: #Invoices
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!Invoices class methodsFor: 'example' stamp: 'hk 6/13/2016 10:42'!
exampleRun
	GbtSVO initializeAll.
	self invoicesContext ui title: #Invoices; open! !

!Invoices class methodsFor: 'things' stamp: 'hk 6/22/2016 17:03'!
invoice
	^GbtThing newStruct: 'Invoice' define: {
		{ #date . #date: . Date today}.
		{ #Sum . #sum: .  #tprice}.
		{ #VAT . #calc: .  '0.19 * #Sum'}.
		{ #totals . #calc: .  '#VAT + #Sum'}.
		{ #items . #listOf: . LittleCompany product}.					
	} full: { 
		{ #customer . #thing: . Rolodex contact}.
	}! !

!Invoices class methodsFor: 'context' stamp: 'hk 6/20/2016 14:36'!
invoiceContext
	^GbtPlainAC newStruct: 'Invoice' define: {
		{#displayAs: . 'Invoice'  } .
		{#uiSpec:icon: . #GbtDiItemUI . #invoices}.
	"integration with other contexts in these 2 lines:"
		{#chooseFor:with: . #customer . Rolodex rolodex }.
		{#chooseFor:with: . #items . LittleCompany productsContext }.
	}! !

!Invoices class methodsFor: 'context' stamp: 'hk 7/30/2016 17:12'!
invoicesContext 
	^GbtBigListAC newStruct: 'Invoices' define: {
		{#displayAs: . 'Invoices'} .
		{#uiSpec:icon: . #GbtListUI . #invoicing} .
		{#templates: . self invoice} .
		{#display: . #(firstName lastName company date Sum VAT totals)} .
		{#subcontext: . self invoiceContext} }! !

TestCase subclass: #LittleCompany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!LittleCompany class methodsFor: 'example' stamp: 'hk 6/23/2016 15:39'!
exampleRun
	| ui |
	GbtSVO initializeAll.
	(ui := self littleCompany ui) title: ('Little Company    ', ui title); open! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 6/16/2016 16:21'!
littleCompany 
	"self littleCompany" 

	^GbtMainAC newStruct: 'LittleCompany' define: {
		{#aspect:on: . LittleCompany productsContext . nil  } .
		{#aspect:on: . Rolodex rolodex . nil  } .
		{#aspect:on: . Invoices invoicesContext . nil } .		
		{#uiSpec:icon: . #GbtMainUI . #main} }! !

!LittleCompany class methodsFor: 'things' stamp: 'hk 6/15/2016 17:21'!
product
	^GbtThing newStruct: 'Product' define: { 
		{ #summary .  '#amount pc à #price € = #total € . #description'}.		
		{ #description . #val: . ''}.		
		{ #amount . #val: . ''}.
		{ #price . #val: . ''}.	
		{ #total . #calc:tag: . '#amount * #price' . #tprice }} ! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 6/22/2016 17:05'!
productContext 
	^GbtPlainAC newStruct: 'ProductContext' define: {
		{#displayAs: . 'Product'  } .
		{#uiSpec:icon: . #GbtDiItemUI . #taskOrders}}! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 7/30/2016 17:12'!
productsContext 
	^GbtBigListAC newStruct: 'ProductsContext' define: {
		{#displayAs: . 'Products'} .
		{#uiSpec:icon: . #GbtListUI . #taskOrders} .
		{#templates: . self product} .
		{#loadPolicy: . #simpleload } .
		{#display: . #( price amount total description)} .
		{#subcontext: . self productContext} }! !

TestCase subclass: #Rolodex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!Rolodex class methodsFor: 'things' stamp: 'hk 5/12/2016 17:01'!
address
	^GbtThing newStruct: 'Address' define: { 
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityName . #val: . ''}.	
		{ #cityCode . #val: . ''}} ! !

!Rolodex class methodsFor: 'things' stamp: 'hk 5/12/2016 17:06'!
contact
	^GbtThing newStruct: 'Contact' define: {
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.
		{ #company . #val: . ''}.					
		{ #eMail . #val: . '' }.					
		{ #phone .  #val: . '' } .
	} full: { 
		{ #address .  #thing: . self address}.
	}! !

!Rolodex class methodsFor: 'contexts' stamp: 'hk 6/22/2016 17:53'!
contactContext 
	self labelDeclarative .
	^GbtPlainAC newStruct: 'ContactContext' define: {
		{#displayAs: . 'Contacts'  } .
		{#uiSpec:icon: . # GbtItemUI . #contacts}.
		{#menu: . #'print label' }.
		{#behavior:actions: . #'print label' . #(COMPOSE LabelDeclarative TOPDF #(etikett pdfSlots) )}}! !

!Rolodex class methodsFor: 'example' stamp: 'hk 6/12/2016 15:14'!
exampleRun
	GbtSVO initializeAll.
	self rolodex ui title: #Rolodex; open! !

!Rolodex class methodsFor: 'declaratives' stamp: 'hk 5/18/2016 16:22'!
labelDeclarative
	^GbtDeclarative newStruct: 'LabelDeclarative' define: { 
		{ #pdfSlots . #decl: . self pdfSlots }.
		{ #firstName }.		
		{ #lastName }.
		{ #address }} ! !

!Rolodex class methodsFor: 'things' stamp: 'hk 5/17/2016 19:57'!
labelSticker
	^GbtThing newStruct: 'Label' define: { 
		{ #nameLine . #ref: . '#firstName #lastName'}.		
		{ #streetLine . #ref: . '#streetNo , #street'}.
		{ #cityLine . #ref: . '#cityCode #cityName' }} ! !

!Rolodex class methodsFor: 'declaratives' stamp: 'hk 5/17/2016 20:00'!
pdfSlots
	^GbtDeclarative newStruct: 'pdfSlots' define: { 
		{ #nameLine }.		
		{ #streetLine }.
		{ #cityLine }} ! !

!Rolodex class methodsFor: 'contexts' stamp: 'hk 7/30/2016 17:12'!
rolodex 
	^GbtBigListAC newStruct: 'Rolodex' define: {
		{#displayAs: . 'Rolodex'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self contact} .
		{#loadPolicy: . #autoload } .
		{#display: . #(firstName lastName company cityName)} .
		{#subcontext: . self contactContext}.
		{#poolThings: . {self labelSticker} }}! !
